#include <stdio.h>

int main(void) {
	int stack[0x40];
	int sp=0x40;
	int label=0;

	printf(	".extern _main\n"
		".sect .text\n\n"
		"_main:\n"
		" mov edi,mem\n"
		" mov ebx,mem\n"
		" mov ecx,0x400\n"
		" xor eax,eax\n"
		" rep\n"
		" stosb\n");

	while(!feof(stdin)) {
		switch(fgetc(stdin)) {
		case '+':
			printf(" incb (ebx)\n");
			break;
		case '-':
			printf(" decb (ebx)\n");
			break;
		case '>':
			printf(" inc ebx\n");
			break;
		case '<':
			printf(" dec ebx\n");
			break;
		case '.':
			printf(" push (ebx)\n call _putchar\n add esp,4\n");
			break;
		case ',':
			printf(" call _getchar\n movb (ebx),al\n");
			break;
		case '[':
			printf(" jmp fwd%d\nback%d:\n",label,label);
			stack[--sp] = label;
			label++;
			break;
		case ']':
			printf("fwd%d:\n cmpb (ebx),0\n jnz back%d\n",
				stack[sp],stack[sp]);
			sp++;
			break;
		};
	}

	printf(	" push 0x0a\n"
		" call _putchar\n"
		" call _exit\n\n"
		".sect .data\n\n"
		".sect .bss\n\n"
		"mem:\n"
		".space 0x400\n");
	return 0;
}

